--------------------------------------------------------------------------------
-- Weapon Trampoline
-- Original Coolo Weapon
-- Script by Coolo, Dezember 2010
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.trampoline={}
cc.trampoline.gfx_wpn={}
cc.trampoline.gen={}

cc.trampoline.gfx_icon = loadgfx("cooloweapon/trampoline.png")
cc.trampoline.gfx_real = loadgfx("cooloweapon/trampocolimg.png")
cc.trampoline.sfx_bounce=loadsfx("bounce.wav")	
cc.trampoline.sfx_jump=loadsfx("pogostick.ogg")
cc.trampoline.gfx_col = loadgfx("cooloweapon/trompolinecoll.png")
setmidhandle(cc.trampoline.gfx_col)
setmidhandle(cc.trampoline.gfx_icon)
setmidhandle(cc.trampoline.gfx_real)
cc.trampoline.id=addweapon("cc.trampoline","Trampoline",cc.trampoline.gfx_icon,0) -- Add Weapon (0 uses)
cc.trampoline.gen.id=addobject("cc.trampoline.gen",cc.trampoline.gfx_real)			-- Add Object

function cc.trampoline.draw()	
	if (weapon_shots==0) then													-- Draw
		hudinfo("Place the trampoline.")
		hudpositioning(pos_build, cc.trampoline.gfx_icon, 300, 1, 1, 1)
	end
end

function cc.trampoline.attack(attack)												-- Attack
	if (weapon_position==1 and weapon_shots==0) then
		createobject(cc.trampoline.gen.id,weapon_x,weapon_y)
		useweapon(1)
		weapon_shots=weapon_shots+1
	end
end


function cc.trampoline.gen.setup(id,parameter)
	if objects==nil then objects={} end
	objects[id]={}
	objects[id].health=50
	objects[id].sy=0
end
function cc.trampoline.gen.draw(id,x,y)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(0)
	drawimage(cc.trampoline.gfx_icon,x,y)
end
function cc.trampoline.gen.update(id,x,y)
	
	if (collision(cc.trampoline.gfx_col, x,y-8, 0, 1, 0)==1) then
		
		local player, speed
		player=playercollision()
		if (collision(cc.trampoline.gfx_col, x,y-4, 0, 1, 0)==1) then
			playerposition(player, getplayerx(player), getplayery(player)-8)
		end
		speed=getplayeryspeed(player)*2.2
		playerpush(player,0.002,-speed)
		cc.trampoline.gen.damage(id,8)
		playsound(cc.trampoline.sfx_jump)
	end
	if projectiles~=nil then
		for k,v in ipairs(projectiles) do
			if ((v.vx~=nil and v.vy~=nil) or (v.sx~=nil and v.sy~=nil)) and (v.x~=nil and v.y~=nil) then
				local tmpx, tmpy
				local tmpsx, tmpsy
				if (v.sx~=nil) then
					tmpsx = v.sx
					tmpsy = v.sy
				end
				if (v.vx~=nil) then
					tmpsx = v.vx
					tmpsy = v.vy
				end
				tmpx = v.x
				tmpy = v.y
				msubt=math.ceil(math.max(math.abs(tmpsx),math.abs(tmpsy))/3)
				msubx=tmpsx/msubt
				msuby=tmpsy/msubt
				tmpI = 0
				for i=1,msubt,1 do
					tmpI = tmpI + 1
					if tmpI > 1000 then break end
					if ((tmpx+msubx)>(x-32) and (tmpy+msuby)>(y-8) and (tmpx+msubx)<(x+32) and (tmpy+msuby)<(y+8)) then
						if (v.sx~=nil) then
							v.sy=-v.sy
						end
						if (v.vx~=nil) then
							v.vy=-v.vy
						end
						playsound(cc.trampoline.sfx_jump)
						cc.trampoline.gen.damage(id,1)
						break
					end
					tmpx = tmpx + msubx
					tmpy = tmpy + msuby
				end
				
			end
		end
	end
	-- Gravity influence on speed
	objects[id].sy=objects[id].sy+getgravity()
	-- Move (in substep loop for optimal collision precision)
	msubt=math.ceil(math.abs(objects[id].sy)/15)
	msuby=objects[id].sy/msubt
	for i=1,msubt,1 do
		y=y+msuby
		-- Collision
		if collision(cc.trampoline.gfx_icon,x,y,1,1,1,-1,id)==1 then
			if (math.abs(objects[id].sy)>0.5) then playsound(cc.trampoline.sfx_bounce) end
			y=y-msuby
			objects[id].sy=-objects[id].sy*0.3
			msuby=-msuby*0.3
		end
		-- Water
		if y>getwatery()-5 then
			-- Effects
			particle(p_waterhit,x,y)
			playsound(sfx_hitwater1)
			-- Remove Generator
			removeobject(id)
			break
		end
	end
	objectposition(id,x,y)
end
function cc.trampoline.gen.damage(id,damage)
	if objects[id].health>0 then 
		objects[id].health=objects[id].health-damage
		if objects[id].health<=0 then
			local x=getobjectx(id)
			local y=getobjecty(id)
			-- Destroy terrain
			terrainexplosion(x,y,30,1)
			-- Crater
			grey=math.random(0,40)
			if math.random(0,1)==1 then
				terrainalphaimage(gfx_crater100,x,y,math.random(6,9)*0.1,grey,grey,grey)
			else
				terrainalphaimage(gfx_crater125,x,y,math.random(6,9)*0.1,grey,grey,grey)
			end
			-- Remove Generator
			removeobject(id)
			-- Cause damage
			arealdamage(x,y,100,50)
		end
	end
end